**************************************************************************
** Program name: dbf2mdb.PRG
** Version: 0.0.0,1
** Create date: 2004-07-23
** Description: Export DBF to MSD
** Author: Martin Jindra
** E-mail: martin.jindra@egservis.cz
** CP: 1250


** Many properties and Methods was passed from PDM
**************************************************************************
#INCLUDE "dbf2mdb.h"


**************************************************************************************************
DEFINE CLASS _dbf2mdb AS Session && Upload DBF file to MDB
   HIDDEN DataSessionID,_DataSessionID,hdbc,Version, Catch 

   * System properties
   Version="0.0.0.1"  && Version
   MainPath=""        && 
   Catch=.F.          && Mode Error catching
   nErr=0             && Error number
   cErrMSG=""         && Message error
   _DataSessionID = 0 && DataSession ID
   hdbc=0             && VFP handle of ODBC connection


   * User properties
   lReCreate=.T.     && If .T. and table exist in dbf file, a table will be delete
   lReFill=.F.       && If .T., old data will be delete
   iFormat=1         && Formt/verze MDB souboru (1 - MS Access 2.0, 2 - MS Access 95/97, 3 - MS Access 2000)
   lMDBReCreate=.F.  && Format/version of MDB file (1 - MS Access 2.0, 2 - MS Access 95/97, 3 - MS Access 2000)

   cTemplateMDB=""   && Template MDB for creating new MDB file
   cTargetMDB=""     && Target MDB

   PROCEDURE Init()
      LOCAL lcPath
      SET EXACT OFF
      SET TALK OFF
      SET DELE ON
      SET SAFETY OFF
      SET DECI TO 2
      SET POINT TO "."

      lcPath=SYS(16)
      lcPath=SUBST(lcPath,AT(" ",lcPath,2)+1)
      STORE IIF(RAT("\",lcPath)>0,LEFT(lcPath,RAT("\",lcPath)),lcPath) TO lcPath,This.MainPath
      
      IF EMPTY(This.cTemplateMDB)
         This.cTemplateMDB=lcPath+"empty.mdb"
      ENDIF
      This._DataSessionID=This.DataSessionID
   ENDPROC

   HIDDEN PROCEDURE Upload(lcAlias)
      LOCAL lcMDB,lcVMDB,lcSQL,lihdbc,liErr,liODBChdbc,lcPom,lii,lcMDBVersion,lcCRKey,lcTable,;
            lcATables,llExists,lcSQLI
      LOCAL ARRAY laErr(1),laFields(1)
      
      * Get out if template mdb not defined or not exists
      IF EMPTY(lcAlias)
         RETURN __DBF2MDB_ErrFewParameters
      ENDIF

      IF !USED(lcAlias)
         RETURN __DBF2MDB_ErrAliasNotOpen
      ENDIF

      lcPom=DBF(lcAlias)
      lii=RAT("\",lcPom)
      lcTable=IIF(lii>0,SUBS(lcPom,lii+1),lcPom)
      lii=RAT(".",lcTable)
      lcTable=IIF(lii>0,LEFT(lcTable,lii-1),lcTable)

      llDal=.T. && Internal flag, All are OK

      lihdbc=This.hdbc
      * Table is exist in MDB
      lcATables=SYS(2015) && 
      IF SQLTABLES(lihdbc,"'TABLE','VIEW','SYSTEM TABLE'",lcATables)<=0
         liErr=__DBF2MDB_ErrNoTables && MDB file have not tables...
         llDal=.F.
      ENDIF

      IF llDal
         STORE "" TO lcSQL,lcPom,lcSQLI
         * Read field list
         FOR lii=1 TO AFIELDS(laFields,lcAlias)
             lcSQL=lcSQL+[ "]+laFields(lii,1)+[" ]+;
                   IIF(laFields(lii,2)='C',"TEXT ("+LTRIM(STR(laFields(lii,3),11))+")",;
                   IIF(laFields(lii,2)='M',"LONGTEXT",;
                   IIF(laFields(lii,2)='Y',"CURRENCY",;
                   IIF(laFields(lii,2)='F',"FLOAT",;
                   IIF(laFields(lii,2)='B',"DOUBLE",;
                   IIF(laFields(lii,2)='I',"INTEGER",;
                   IIF(laFields(lii,2)='N',"SINGLE" ,;
                   IIF(laFields(lii,2)$'D,T',"DATETIME",;
                   IIF(laFields(lii,2)='G',"LONGBINARY","BIT")))))))))+" "+IIF(laFields(lii,5),"NULL,","NOT NULL,")

             lcSQLI=lcSQLI+" ["+laFields(lii,1)+"], "
             lcPom=lcPom+"?"+lcAlias+"."+laFields(lii,1)+", "
         NEXT
         lcSQL="CREATE TABLE "+lcTable+" ("+LEFT(lcSQL,LEN(lcSQL)-1)+")"
         lcSQLI="INSERT INTO "+lcTable+" ("+LEFT(lcSQLI,LEN(lcSQLI)-2)+") VALUES ("+LEFT(lcPom,LEN(lcPom)-2)+")"

         SELE (lcATables)
         LOCATE FOR UPPER(ALLT(TABLE_NAME))==UPPER(lcTable)
         llExists=FOUND()

         * Test if table exist and can be recreate, but is it View or System Table
         IF llExists AND This.lReCreate AND UPPER(ALLT(TABLE_TYPE))=='VIEW' OR UPPER(ALLT(TABLE_TYPE))=='SYSTEM TABLE'
            llDal=.F.
            liErr=__DBF2MDB_ErrNotaTable
            =AERROR(laErr)
         ENDIF
      ENDIF

      IF llDal AND (!llExists OR This.lReCreate)
         * Drop table
         IF llExists AND SQLEXEC(lihdbc,"DROP TABLE "+lcTable)<=0
            llDal=.F.
            liErr=__DBF2MDB_ErrCannotDTable
            =AERROR(laErr)
         ENDIF

         * Create Table
         IF llDal AND SQLEXEC(lihdbc,lcSQL)<=0
            llDal=.F.
            liErr=__DBF2MDB_ErrCannotCTable
            =AERROR(laErr)
         ENDIF
      ENDIF

      IF USED(lcATables) && Close cursor
         USE IN (lcATables)
      ENDIF

      * Delete all records if table exist and not be create and be fill
      IF llDal AND llExists AND !This.lReCreate AND This.lReFill AND SQLEXEC(lihdbc,"DELETE FROM "+lcTable)<=0
         liErr=__DBF2MDB_ErrNotDelete
         =AERROR(laErr)
         llDal=.F.
      ENDIF

      IF llDal
         liErr=__DBF2MDB_ErrOK
         SELE (lcAlias)
         =SQLPREPARE(lihdbc,lcSQLI)
         SCAN ALL
             IF SQLEXEC(lihdbc,lcSQLI)<=0
                liErr=__DBF2MDB_ErrNotInsert
                =AERROR(laErr)
                EXIT
             ENDIF
         ENDSCAN
         * If not Auto Transaction, commit changes or rollback it
         =IIF(SQLGETPROP(lihdbc,"Transactions")=2,IIF(liErr=__DBF2MDB_ErrOK,SQLCOMMIT(lihdbc),SQLROLLBACK(lihdbc)),.T.)
      ENDIF

      =This.Uploaded(DBF(lcAlias), liErr,laErr)
      RETURN liErr
   ENDPROC

   PROCEDURE GetVersion() && Return version
      RETURN This.Version
   ENDPROC

   PROCEDURE UploadDBC(lcDBC,llOpen) && Upload all tables from DBC 
      * lcDBC  - Folder and Name od DBC
      * llOpen - Open flag
      LOCAL lcAlias,liCount,lii,liErr

      liErr=This.OpenRemoteDB(This.cTargetMDB,This.cTemplateMDB)
      IF liErr#__DBF2MDB_ErrOK
         RETURN liErr
      ENDIF

      IF IIF(llOpen,This.OpenDBC(-1,lcDBC,"")#__DBF2MDB_ErrOK,!DBUSED(lcDBC))
         RETURN __DBF2MDB_ErrDBCNotOpen
      ENDIF

      liCount=ADBOBJECTS(laTables, "TABLE")
      lcAlias=SYS(2015)

      FOR lii=1 TO liCount

          IF This._UploadDBF(laTables(lii),lcAlias,"IN 0 NOUPDATE")=__DBF2MDB_ErrOK && Open table
       
          ELSE

          ENDIF
      NEXT
      This.CloseRemoteDB()
      IF llOpen
         CLOSE DATABASE
      ENDIF
      RETURN __DBF2MDB_ErrOK
   ENDPROC

   HIDDEN PROCEDURE _UploadDBF(lcDBF,lcAlias,lcParams) && Upload DBF
      * lcDBF    - DBF
      * lcAlias  - Alias
      * lcParams - Parameters

      LOCAL liErr
      liErr=IIF(EMPTY(lcDBF),;
             IIF(USED(lcAlias),__DBF2MDB_ErrOK,__DBF2MDB_ErrAliasNotOpen),;
             This.OpenTable(-1,lcDBF,lcAlias,lcParams))
      IF liErr=__DBF2MDB_ErrOK && Open table
         liErr=This.Upload(lcAlias)
         =IIF(EMPTY(lcDBF),.T.,This.CloseTable(-1,lcAlias))
      ENDIF

      RETURN liErr
   ENDPROC

   PROCEDURE UploadDBF(lcDBF,lcAlias,lcParams) && Upload DBF
      * lcDBF    - DBF
      * lcAlias  - Alias
      * lcParams - Parameters

      LOCAL liErr
      liErr=This.OpenRemoteDB(This.cTargetMDB,This.cTemplateMDB)
      IF liErr#__DBF2MDB_ErrOK
         RETURN liErr
      ENDIF

      liErr=IIF(EMPTY(lcDBF),;
             IIF(USED(lcAlias),__DBF2MDB_ErrOK,__DBF2MDB_ErrAliasNotOpen),;
             This.OpenTable(-1,lcDBF,lcAlias,lcParams))
      IF liErr=__DBF2MDB_ErrOK && Open table
         liErr=This.Upload(lcAlias)
         =IIF(EMPTY(lcDBF),.T.,This.CloseTable(-1,lcAlias))
      ENDIF

      This.CloseRemoteDB()

      RETURN liErr
   ENDPROC

   PROCEDURE Error(nError,cMethod,nLine) && Error routine
      * nError  - Error number
      * cMethod - Method name
      * nLine   - Row number

      IF ISNULL(m.This.Catch)
         This.nErr=nError
         This.cErrMSG=MESSAGE()
         RETURN
      ENDIF

      IF This.Catch
         m.This.nErr=nError
         This.cErrMSG=MESSAGE()
      ELSE
      ENDIF
   ENDPROC

   PROCEDURE SetCatch(llCatch) && Seting mode of catching error
      LOCAL luCatch
      luCatch=m.This.Catch
      This.Catch=llCatch
      IF llCatch && If have error catch
         * Reset Error info
         This.nErr=0
         This.cErrMSG=""
      ENDIF
      RETURN luCatch && Return old value
   ENDPROC

   PROCEDURE OpenDBC(liDSID,lcDBC,lcParam) && Open DBC konteiner
      * liDSID  - ID Data Session
      * lcDBC  -  Directory and Name DBC container
      * lcParam - Parameters

      LOCAL liDSIDOld,luCatch
      liDSIDOld=m.This.DataSessionID &&  Remember Datasession ID
      luCatch=m.This.SetCatch(.T.) && Set chatch error
      IF liDSID>=0
         SET DATASESSION TO liDSID && Set new Datasession ID
      ENDIF
      OPEN DATA (lcDBC) &lcParam.
      SET DATASESSION TO (liDSIDOld) && Set datasession ID
      m.This.SetCatch(luCatch) && Cancel chatch error
      RETURN m.This.nErr && Return number Error
   ENDPROC

   PROCEDURE OpenTable(liDSID,lcFile,lcAlias,lcParam) && Open Table
      * liDSID  - ID Data Session
      * lcFile  - Folder and name DBF file
      * lcAlias - Alias 
      * lcParam - Parameters

      LOCAL liDSIDOld,luCatch
      liDSIDOld=m.This.DataSessionID
      luCatch=m.This.SetCatch(.T.)
      IF liDSID>=0
         SET DATASESSION TO liDSID
      ENDIF
      USE (lcFile) ALIAS (lcAlias) &lcParam.
      SET DATASESSION TO (liDSIDOld)
      m.This.SetCatch(luCatch)
      RETURN m.This.nErr
   ENDPROC

   PROCEDURE CloseTable(liDSID,lcAlias) && Close Table
      * liDSID  - ID Data Session
      * lcAlias - Alias 
      LOCAL liDSIDOld
      liDSIDOld=m.This.DataSessionID
      IF liDSID>=0
         SET DATASESSION TO liDSID
      ENDIF
      IF USED(lcAlias)
         USE IN (lcAlias)
      ENDIF
      SET DATASESSION TO (liDSIDOld)
      RETURN m.This.nErr
   ENDPROC

   PROCEDURE Uploaded(lcTable,liErr,laErr) && Event - after uploading table
      * lcTable - Table Name
      * liErr   - Number of Error
      * laErr   - VFP Error Array
   ENDPROC

   PROCEDURE AttachDataSession(liDSID) && Attach Another datasession
      SET DATASESSION TO liDSID
   ENDPROC

   PROCEDURE RestoreDataSession(liDSID) && Restore datasession
      SET DATASESSION TO (m.This._DataSessionID)
   ENDPROC


   PROCEDURE CreateRemoteDB(lcMDB,lcVMDB) && Create new MDB file
      * lcMDB  - Target MDB file
      * lcVMDB - Template MDB file

      LOCAL lcMDB,lcVMDB,lcSQL,lihdbc,liODBChdbc,lii,lcMDBVersion,lcCRKey
            
      * ODBC API function
      DECLARE Integer SQLConfigDataSource in odbccp32.dll Integer, Integer,String, String
      DECLARE INTEGER SQLGetInfo IN odbc32.dll INTEGER,INTEGER, STRING @,INTEGER,INTEGER @

      * How is version of ODBC driver for MS Access?
      * ( because key words are different for various version ODBC drivers)
      lihdbc=SQLSTRINGCONNECT("driver={Microsoft Access driver (*.mdb)};dbq="+lcVMDB)
      IF lihdbc=0
         RETURN __DBF2MDB_ErrConnectionFailed
      ENDIF
      liODBChdbc=SQLGETPROP(lihdbc,"ODBChdbc") &&
      lcVersion=SPACE(254) &&
      lii=0
      =SQLGetInfo(liODBChdbc,SQL_DRIVER_VER,@lcVersion,LEN(lcVersion),@lii) && Nati verzi driveru
      =SQLDISCONNECT(lihdbc)

      * Create key word
      lcVersion=LTRIM(STR(VAL(LEFT(lcVersion,AT(".",lcVersion)-1)),3))
      lcCRKey = IIF(lcVersion="3",IIF(This.iFormat=1,"CREATE_V2DB","CREATE_DB"),;
                IIF(This.iFormat=1,"CREATE_DBV2",IIF(This.iFormat=2,"CREATE_DBV3","CREATE_DBV4")))

      IF FILE(lcMDB) && If MDB file exist
         DELE FILE (lcMDB) && delete it
      ENDIF

      * Create new mdb
      IF SQLConfigDataSource(0,1,"Microsoft Access Driver (*.mdb)",lcCRKey+"="+lcMDB)#1
         * Creating MDB file - fail
         RETURN __DBF2MDB_ErrMDBNotCreated
      ENDIF
      RETURN __DBF2MDB_ErrOK
   ENDPROC

   PROCEDURE OpenRemoteDB(lcMDB,lcVMDB) && Open MDB file
      * lcMDB  - Target MDB file
      * lcVMDB - Template MDB file
      LOCAL liErr,lihdbc

      * Get out if template mdb not defined or not exists
      IF !FILE(lcMDB) AND (EMPTY(lcVMDB) OR !FILE(lcVMDB))
         RETURN __DBF2MDB_ErrFewParameters
      ENDIF

      IF !FILE(lcMDB) OR This.lMDBReCreate
         liErr=This.CreateRemoteDB(@lcMDB,@lcVMDB)
         IF liErr#__DBF2MDB_ErrOK
            RETURN liErr
         ENDIF
      ENDIF

      * Connect to MDB file
      STORE SQLSTRINGCONNECT("Driver={Microsoft Access Driver (*.mdb)};DBQ="+lcMDB) TO lihdbc,This.hdbc
      IF lihdbc<=0
         RETURN __DBF2MDB_ErrConnectionFailed
      ENDIF
      =SQLSETPROP(lihdbc,"Asynchronous",.F.) && Set Asynchronnous 
      =SQLSETPROP(lihdbc,"Transactions",1)   && Set Auto Transactions
      =SQLSETPROP(lihdbc,"DispLogin",3)      && Don't show dialog for login
      RETURn __DBF2MDB_ErrOK
   ENDPROC

   PROCEDURE CloseRemoteDB() && Close MDB file
      =SQLDISCONNECT(This.hdbc)
      This.hdbc=0
   ENDPROC

ENDDEFINE